/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : February, 1997                                                 */
/* File Name : JSSPInitializerImpl.cc                                    */
/*************************************************************************/
/*************************************************************************/

#include "JSSPInitializer.h"
#include "JSSPChromosomes.h"
#include "JSSPSolution.h"
#include <Initializer.h>
#include <Population.h>
#include <Chromosomes.h>
#include <stdio.h>
#include <iostream.h>
#include <iomanip.h>

JSSPInitializer::JSSPInitializer(JSSProblem *Pr)
{  JSSPChromosomes k;
   cout << " JSSPChromosome is defined " << endl;
   k.setProblem(*Pr);
   a = (Chromosomes *) (&k);
   cout << *((JSSPSolution*)(&k)); 
   myProblem = Pr;
}// end of constructor

void JSSPInitializer::updateFromPopulation(Population& Pop, 
			Chromosomes *ChroList[], int Size)
{
   int i;
   for(i=0;i<Size;i++) Pop.addChromosomes(ChroList[i]);

}// end of updateFromPopulation()

void JSSPInitializer::apply(Population & Pop)
{  int i, limit = Pop.getSize();
   cout << " in JSSPInitializer::apply() " << endl;

   JSSPChromosomes *k;

   for(i=0;i<limit;i++)
   {  k = new JSSPChromosomes; 
      cout << " in JSSPInitializer::apply() created the object " << endl;
      (*k).setProblem(*myProblem);
      (*k).randomInitialize();
      if(!(*k).isFeasible()) (*k).restore();
      cout << "  (*k).randomInitialize() is safe " << endl;
      Pop.addChromosomes(k);
      cout << i << "th chromosome is added " << endl;
   }// end of for

   cout << Pop;

   cout << "Before the  Pop.printFitnessValues( " << endl;
   Pop.printFitnessValues(cout);
   cout << "After the  Pop.printFitnessValues( " << endl;

}// end of apply()
